
typedef struct AL_BANKHEAD
{
	char str[8];	//
	int headsize;	//wb_TCY
	int bankcnt;	//oN
} AL_BANKHEAD;

typedef struct AL_BANKDATA
{
	int size;		//TCY
	BYTE headsize;	//wb_TCY
	BYTE No;		//oNio[
	BYTE palt;		//pbgx(9,12,15,16,24)
	BYTE strsize;
	int sx;			//
	int sy;			//
} AL_BANKDATA;

int ifstr(char *a, char *b)
{
	int i=0;
	while(1)
	{
		if (a[i]==0 && b[i]==0) return 1;
		if (a[i]!=b[i]) return 0;
		i++;
	}
}

int bsave(char *filename,BYTE *data,int size)
{
	HANDLE hFile;
	DWORD wsize;

	hFile=CreateFile( filename,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);
	//Õt@_Ƃ..
	if (hFile==INVALID_HANDLE_VALUE) return 1;
	WriteFile( hFile,data,size,&wsize,NULL);
	CloseHandle(hFile);
	return 0;
}

int bload(BYTE **data, char *filename)
{
	int size;
	DWORD _size;
	HANDLE hFile;

	hFile=CreateFile(filename,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	size=GetFileSize(hFile,0);
	if (size<=0){ CloseHandle(hFile); return 0; }	//t@CȂ
	SetFilePointer(hFile,0,0,FILE_BEGIN);

	*data=(BYTE *)malloc(size);
	ReadFile(hFile,*data,size,&_size,0);
	CloseHandle(hFile);

	return size;
}

//*p    ǂݎ茳obt@
//index ʒu
//bsize rbg̃TCY(1-8)
int bitpeek(BYTE *p,int index,int bsize)
{
	int i;
	int mask1,mask2,pidx,val1,val2;
	int bidx1,bidx2=0;

	pidx=index*bsize >>3;					//擪̃|C^߂

	bidx1=index*bsize &7;					//1oCg̃rbgʒu(O)
	if (bidx1+bsize>8) bidx2=bsize+bidx1&7;	//oCg܂㔼̃rbg

	i=(0xFF<<(8-bsize)&0xFF)<<8;
	mask1=i>>(bidx1+8);						//O}XN
	mask2=i>>bidx1 &0xFF;					//㔼}XN

	val1=p[pidx]&mask1;						//O̒l
	if (bidx2>0){
		val2=(p[pidx+1]&mask2)>>(8-bidx2);	//㔼̒l
		val1=val2+(val1<<bidx2);
	}else{
		val1>>=8-(bsize+bidx1);
	}

	return val1;
}



